/*
	General libsharedmime API

	This is the public API of libsharedmime.
	
	Author: freedesktop.org
	Date: 5/12/2003
*/

#ifndef _SHARED_MIME_H_
#define _SHARED_MIME_H_

#define MIME_DIR_GLOBAL			"/usr/share/mime"
#define MIME_DIR_LOCAL			"/usr/local/share/mime"
#define MIME_DIR_USER			"~/.local/share/mime"

#define MIMETYPES_VERSION		"0.5"
#define MIMETYPES_NAMESPACE		"http://www.freedesktop.org/standards/shared-mime-info"

#define CONST_RETURN			const

typedef enum
{
	MIMETYPES_CHECK_PATH		= 1,
	MIMETYPES_CHECK_CONTENTS	= 2,
	MIMETYPES_CHECK_ALL			= 3
}
mimetypes_flags;

#ifdef __cplusplus
extern "C"
{
#endif

extern const char *mimetypes_identity;
extern const char *mimetypes_version;

void
mimetypes_init(void);

CONST_RETURN char *
mimetypes_set_default_type(const char *default_type);

CONST_RETURN char *
mimetypes_get_file_type(const char *pathname, mimetypes_flags flags);

CONST_RETURN char *
mimetypes_get_data_type(const void *data, const int length);

bool
mimetypes_decode(const char *type, char **media_type, char **sub_type);

char *
mimetypes_convert_filename(const char *pathname, const char *mime_type);

extern bool
mimetypes_add_mime_dir(const char *path, bool high_priority, bool rescan);

bool
mimetypes_add_mime_dir(const char *path, bool high_priority, bool rescan);

CONST_RETURN char *
mimetypes_get_type_info(const char *mime_type, const char *lang);

#ifdef __cplusplus
}
#endif

#endif